import { EntityRepository, Repository } from "typeorm";
import { UpdateFooterCmsDto } from "./dto/update-footer-cms.dto";
import { FooterCms } from "./entities/footer-cms.entity";

@EntityRepository(FooterCms)
export class FooterCmsRepository extends Repository<FooterCms> {

    async createEntity(dto: UpdateFooterCmsDto): Promise<FooterCms | Error> {
        try {
            const entity = this.create({
                copyrightText: dto.copyrightText,
                title: dto.title,
                description: dto.description,
                subTitle: dto.subTitle,
                buttonOneText: dto.buttonOneText,
                buttonTwoText: dto.buttonTwoText,
                buttonOneLink: dto.buttonOneLink,
                buttonTwoLink: dto.buttonTwoLink,
                sectionTwoTitle: dto.sectionTwoTitle,
                sectionTwoSubTitle: dto.sectionTwoSubTitle,
                sectionTwoButtonText: dto.sectionTwoButtonText,
                sectionTwoButtonLink: dto.sectionTwoButtonLink
            });
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async updateEntity(dto: UpdateFooterCmsDto, id: string): Promise<FooterCms | Error> {
        try {
            await this.update(id, {
                copyrightText: dto.copyrightText,
                title: dto.title,
                description: dto.description,
                subTitle: dto.subTitle,
                buttonOneText: dto.buttonOneText,
                buttonTwoText: dto.buttonTwoText,
                buttonOneLink: dto.buttonOneLink,
                buttonTwoLink: dto.buttonTwoLink,
                sectionTwoTitle: dto.sectionTwoTitle,
                sectionTwoSubTitle: dto.sectionTwoSubTitle,
                sectionTwoButtonText: dto.sectionTwoButtonText,
                sectionTwoButtonLink: dto.sectionTwoButtonLink
            });
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<FooterCms[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }
}