import { Body, Controller, Get, HttpCode, HttpStatus, Post, UseGuards } from "@nestjs/common";
import { AdminAuthGuard } from "src/core/guards/admin-auth.guard";
import { Constants } from "src/utils/constants";
import { UpdateHomePageSectionEightCmsDto } from "./dto/update-home-page-section-eight-cms.dto";
import { HomePageSectionEightCmsService } from "./home-page-section-eight-cms.service";

@Controller({ path: "home-page-section-eight-cms", version: Constants.API_VERSION_1 })

export class HomePageSectionEightCmsController {
    constructor(private readonly service: HomePageSectionEightCmsService) {
    }

    @Post()
    @HttpCode(HttpStatus.OK)
    @UseGuards(AdminAuthGuard)
    updateOrCreateData(
      @Body() dto: UpdateHomePageSectionEightCmsDto
    ) {
        return this.service.updateOrCreateData(dto);
    }

    @Get()
    // @UseGuards(AdminAuthGuard)
    findAll() {
        return this.service.findAll();
    }
}
