import { EntityRepository, Repository } from "typeorm";
import { UpdateHomePageSectionFiveCmsDto } from "./dto/update-home-page-section-five-cms.dto";
import { HomePageSectionFiveCms } from "./entities/home-page-section-five-cms.entity";

@EntityRepository(HomePageSectionFiveCms)
export class HomePageSectionFiveCmsRepository extends Repository<HomePageSectionFiveCms> {

    async createEntity(dto: UpdateHomePageSectionFiveCmsDto): Promise<HomePageSectionFiveCms | Error> {
        try {
            const entity = this.create({
                title: dto.title,
                subTitle: dto.subTitle,
                buttonLink: dto.buttonLink,
                buttonText: dto.buttonText,
                status: dto.status
            });
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async updateEntity(dto: UpdateHomePageSectionFiveCmsDto, id: string): Promise<HomePageSectionFiveCms | Error> {
        try {
            await this.update(id, {
                title: dto.title,
                subTitle: dto.subTitle,
                buttonLink: dto.buttonLink,
                buttonText: dto.buttonText,
                status: dto.status
            });
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<HomePageSectionFiveCms[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }
}