import { Body, Controller, Get, HttpCode, HttpStatus, Post, UseGuards } from "@nestjs/common";
import { AdminAuthGuard } from "src/core/guards/admin-auth.guard";
import { Constants } from "src/utils/constants";
import { HomePageSectionTwoCmsService } from "./home-page-section-two-cms.service";
import { UpdateHomePageSectionTwoCmsDto } from "./dto/update-home-page-section-two-cms.dto";

@Controller({ path: "home-page-section-two-cms", version: Constants.API_VERSION_1 })

export class HomePageSectionTwoCmsController {
    constructor(private readonly service: HomePageSectionTwoCmsService) {
    }

    @Post()
    @HttpCode(HttpStatus.OK)
    @UseGuards(AdminAuthGuard)
    updateOrCreateData(
      @Body() dto: UpdateHomePageSectionTwoCmsDto
    ) {
        return this.service.updateOrCreateData(dto);
    }

    @Get()
    // @UseGuards(AdminAuthGuard)
    findAll() {
        return this.service.findAll();
    }
}
