import { EntityRepository, Repository } from "typeorm";
import { UpdatePageTitleCmsDto } from "./dto/update-page-title-cms.dto";
import { PageTitleCms } from "./entities/page-title-cms.entity";

@EntityRepository(PageTitleCms)
export class PageTitleCmsRepository extends Repository<PageTitleCms> {

    async createEntity(dto: UpdatePageTitleCmsDto): Promise<PageTitleCms | Error> {
        try {
            const entity = this.create({
                loginPageTitle: dto.loginPageTitle,
                signupPageTitle: dto.signupPageTitle,
                homePageTitle: dto.homePageTitle,
                shopPagetitle: dto.shopPagetitle,
                productDetailsPageTitle: dto.productDetailsPageTitle,
                cartPageTitle: dto.cartPageTitle,
                dailyDealsPageTitle: dto.dailyDealsPageTitle,
                jarsPlusPageTitle: dto.jarsPlusPageTitle,
                aboutUsPageTitle: dto.aboutUsPageTitle,
                contactUsPageTitle: dto.contactUsPageTitle,
                faqPageTitle: dto.faqPageTitle,
                careerPageTitle: dto.careerPageTitle,
                careerDepartmentPageTitle: dto.careerDepartmentPageTitle,
                careerDetailsPageTitle: dto.careerDetailsPageTitle,
                privacyPageTitle: dto.privacyPageTitle,
                termsPageTitle: dto.termsPageTitle,
                articlesPageTitle: dto.articlesPageTitle,
                articleDetailsPageTitle: dto.articleDetailsPageTitle,
                pressReleasePageTitle: dto.pressReleasePageTitle,
                pressReleaseDetailsPageTitle: dto.pressReleaseDetailsPageTitle,
                cookiesSettingsPageTitle: dto.cookiesSettingsPageTitle,
                profilePageTitle: dto.profilePageTitle,
                successPageTitle: dto.successPageTitle,
                storeDetailsPageTitle: dto.storeDetailsPageTitle,
                retailerPageTitle: dto.retailerPageTitle,
                orderPageTitle: dto.orderPageTitle,
                myItemsPageTitle: dto.myItemsPageTitle,
                getDirectionPageTitle: dto.getDirectionPageTitle,
                forgotPasswordPageTitle: dto.forgotPasswordPageTitle,
                resetPasswordPageTitle: dto.resetPasswordPageTitle,
                reviewPageTitle: dto.reviewPageTitle,
                invoicePageTitle: dto.invoicePageTitle,
                categoryPageTitle: dto.categoryPageTitle,
                ageVerificationPageTitle: dto.ageVerificationPageTitle
            });
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async UpdateEntity(dto: UpdatePageTitleCmsDto, id: string): Promise<PageTitleCms | Error> {
        try {
            await this.update(id, {
                loginPageTitle: dto.loginPageTitle,
                signupPageTitle: dto.signupPageTitle,
                homePageTitle: dto.homePageTitle,
                shopPagetitle: dto.shopPagetitle,
                productDetailsPageTitle: dto.productDetailsPageTitle,
                cartPageTitle: dto.cartPageTitle,
                dailyDealsPageTitle: dto.dailyDealsPageTitle,
                jarsPlusPageTitle: dto.jarsPlusPageTitle,
                aboutUsPageTitle: dto.aboutUsPageTitle,
                contactUsPageTitle: dto.contactUsPageTitle,
                faqPageTitle: dto.faqPageTitle,
                careerPageTitle: dto.careerPageTitle,
                careerDepartmentPageTitle: dto.careerDepartmentPageTitle,
                careerDetailsPageTitle: dto.careerDetailsPageTitle,
                privacyPageTitle: dto.privacyPageTitle,
                termsPageTitle: dto.termsPageTitle,
                articlesPageTitle: dto.articlesPageTitle,
                articleDetailsPageTitle: dto.articleDetailsPageTitle,
                pressReleasePageTitle: dto.pressReleasePageTitle,
                pressReleaseDetailsPageTitle: dto.pressReleaseDetailsPageTitle,
                cookiesSettingsPageTitle: dto.cookiesSettingsPageTitle,
                profilePageTitle: dto.profilePageTitle,
                successPageTitle: dto.successPageTitle,
                storeDetailsPageTitle: dto.storeDetailsPageTitle,
                retailerPageTitle: dto.retailerPageTitle,
                orderPageTitle: dto.orderPageTitle,
                myItemsPageTitle: dto.myItemsPageTitle,
                getDirectionPageTitle: dto.getDirectionPageTitle,
                forgotPasswordPageTitle: dto.forgotPasswordPageTitle,
                resetPasswordPageTitle: dto.resetPasswordPageTitle,
                reviewPageTitle: dto.reviewPageTitle,
                invoicePageTitle: dto.invoicePageTitle,
                categoryPageTitle: dto.categoryPageTitle,
                ageVerificationPageTitle: dto.ageVerificationPageTitle
            });
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<PageTitleCms[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }
}